 // mvport package v2
// Author: Alberto Dorantes, July, 2016
// cdorante@itesm.mx

version 11.0
mata:
mata set matastrict on
real matrix function m_expvar(real matrix r, real scalar lamda, real matrix W, string scalar casewis, real matrix weights)
{ real matrix COVA
real scalar i, j, N
if (lamda==-1) {

   if (casewis!="") {
   
     COVA=m_variance1(r, weights) 

   }
   
   else {
     COVA=m_calcvar(r, weights) 
   }
   W=weights[.,1]
   }
   else {
   N=rows(r)
   W=J(N,1,.)
   j=0
     for (i=1; i<=N; i++) {
 	   W[i,1] = (1-lamda)*(lamda)^(N-i)
	   j=j+W[i,1]
	 }
	 W = W + J(N,1,(1-j)/N)
	 COVA=m_calcvar(r, W) 
   }
   return(COVA)
   st_numscalar("r(cov)",COVA)
}   
end
mata: mata mosave m_expvar(), dir(PERSONAL) replace
