// mvport package v2
// Author: Alberto Dorantes, July, 2016
// cdorante@itesm.mx
version 11.0
mata:
mata clear
mata set matastrict on

mata:
real vector function m_gmvf(real matrix COV)
{ 
  real matrix INVCOV
INVCOV=cholinv(COV)
if (missing(INVCOV[1,1])) {
  printf("The VAR-COVAR MATRIX is NOT positive definite. It will be estimated with general inverse function.\n")
  INVCOV=invsym(COV)
}

return(rowsum(INVCOV) / sum(INVCOV))
}   
end
mata: mata mosave m_gmvf(), dir(PERSONAL) replace
