// mvport package v2
// Author: Alberto Dorantes, July, 2016
// cdorante@itesm.mx
version 11.0
mata:
mata clear
mata set matastrict on
real vector function m_gmvport(string scalar varlist, real matrix vecweights, string scalar touse, string scalar casewis, real matrix covmatrix, real matrix mrets, real matrix vecmaxweights, real scalar noshort)
{
real matrix r, covmat, COV, MR, VAR1, WFS, VAR1_sort, WT, mcr, cr, betas, pcr
real scalar sigue, retp, riskp, varp, j, maxwei, coltodelete, extraweight, csum
real vector vecw, vecmaxw
real vector W, WI, WF, WF1, Wdif, Wdifsort, Wind, sumvar

sigue=1
st_view(r=.,.,tokens(varlist), touse)
maxwei=1
VAR1=J(100,2,0)
if (cols(covmatrix)<=1) {
 COV=m_expvar(r,-1,WT,casewis,J(1,1,1))
 }
else {
  COV=covmatrix
}  
covmat=COV
vecw=vecweights[.,1]
vecmaxw=vecmaxweights[.,1]
Wind=J(cols(r),1,.)
Wind=range(1,cols(r),1)
j=0
while (sigue & cols(covmat)>1) {
  j=j+1
  if (noshort==1) { 
   W = m_gmvportwos2(vecw,covmat)
  }
  else {
   W = m_gmvportws(covmat)
  } 
  if (j>1) {
    sumvar = colsum(covmat)'
	sumvar = J(rows(covmat),1,max(sumvar)) - sumvar
	csum=sum(sumvar)
	sumvar = sumvar/csum
    WFS=J(rows(covmat),100,0)
	for (j=0; j<=99; j++) {
	 WFS[.,j+1]=(j/100)*(maxwei*W) + (100-j)/100*(WF+extraweight*sumvar)
     WF1=m_buildwvector(vecmaxweights, Wind, WFS[.,j+1])
	 VAR1[j+1,1]=cross(WF1,COV)*WF1
	 VAR1[j+1,2]= (min(WF1-vecweights)<0)
    }	
	VAR1_sort=order(VAR1,(2,1))
	WF=WFS[.,VAR1_sort[1]]

 }
  else {
    WF=W
  }
  Wdif=vecmaxw - WF
  Wdifsort=order(Wdif,1)
  coltodelete=Wdifsort[1]
  sigue = (Wdif[coltodelete] < 0 ? 1: 0)
  if (sigue) {
     extraweight=-1*Wdif[coltodelete]
	 maxwei=maxwei - vecmaxw[coltodelete]
	 covmat=m_dropcolren(covmat,coltodelete)
	 vecw=m_dropren(vecw,coltodelete)
	 vecmaxw=m_dropren(vecmaxw,coltodelete) 
	 Wind=m_dropren(Wind,coltodelete)
	 WF=m_dropren(WF,coltodelete)
	 if (rows(WF)==1) { 
	   WF[1]=maxwei
	 }
  }
} 

WI=vecmaxweights[.,1]
for (j=1; j<=rows(Wind); j++) {
   WI[Wind[j]]=WF[j]
}
W=WI

if (rows(mrets)<=1) {
  MR=m_exprets(r, -1,WT,casewis,J(1,1,1))
}
else {
  MR=mrets
} 
retp=quadcross(W,MR)
varp=quadcross(W,COV)*W
riskp=sqrt(varp)
mcr=  COV*W :/ riskp
cr = mcr :*W
pcr = cr :/ riskp
betas = mcr :/ riskp
st_matrix("r(pesos)",W)
st_matrix("r(cov)",COV)
st_matrix("r(exprets)",MR)
st_matrix("r(mcr)",mcr)
st_matrix("r(cr)",cr)
st_matrix("r(pcr)",pcr)
st_matrix("r(betas)",betas)
st_numscalar("r(retp)",retp)
st_numscalar("r(varp)",varp)
st_numscalar("r(sdp)",riskp)
st_numscalar("r(N)",rows(r))
return(W)
}
end
mata: mata mosave m_gmvport(), dir(PERSONAL) replace
