// mvport package v2
// Author: Alberto Dorantes, July, 2016
// cdorante@itesm.mx
version 11.0
mata:
mata set matastrict on

mata:
real vector function m_meanrets(string scalar varlist, string scalar touse, real scalar leweight, string scalar casewis, real matrix weights, real scalar calcsimple)
{ real vector MR
  real matrix r, W, r1

   st_view(r=.,.,tokens(varlist), touse)
   if (calcsimple==1) {
     r1=r+J(rows(r),cols(r),1)
	 r=ln(r1)
   }
   MR=m_exprets(r, leweight, W, casewis, weights)
   st_matrix("r(meanrets)",MR)
   if (W==J(1,1,1)) { 
     W=J(rows(r), 1, 1/rows(r))
   } 
   st_matrix("r(W)", W)
   st_numscalar("r(maxret)",max(MR))
   st_numscalar("r(minret)",min(MR))
   st_numscalar("r(numvar)",rows(MR))
   st_numscalar("r(N)", rows(r))
   return(MR)
}   
end
mata: mata mosave m_meanrets(), dir(PERSONAL) replace
