// mvport package v2
// Author: Alberto Dorantes, July, 2016
// cdorante@itesm.mx
version 11.0
mata:
mata clear
mata set matastrict on
real vector function m_mvport2(string scalar varlist, real scalar ret, real matrix vecweights, string scalar touse, string scalar casewis, real matrix covmatrix, real matrix mrets, real matrix vecmaxweights, real scalar noshort)
{
real matrix r, covmat, COV, MR, VAR1, VAR1_sort, WFS, WT, mcr, cr, pcr, betas
real scalar sigue, retp, riskp, varp, j, i, k, maxwei, coltodelete, rettemp, extraweight, dif, mwei, mwei2, csum, ind_max
real vector vecw, vecmaxw
real vector W, WI, Wdif, Wdifsort, Wind, WN, WF, sumvar, sumvari, WF1, WF2, dd, ddi

st_view(r=.,.,tokens(varlist), touse)
sigue=1
maxwei=1
VAR1=J(100,2,0)

if (cols(covmatrix)<=1) {
 COV=m_expvar(r,-1,WT,casewis, J(1,1,1))
 }
else {
  COV=covmatrix
}  
covmat=COV
if (rows(mrets)<=1) {
  MR=m_exprets(r, -1,WT,casewis, J(1,1,1))
}
else {
  MR=mrets
} 
mrets=MR

vecw=vecweights[.,1]
vecmaxw=vecmaxweights[.,1]
Wind=J(cols(r),1,.)
Wind=range(1,cols(r),1)
i=0
rettemp=ret
while (sigue & cols(covmat)>1) {  // 1 while
  i++
  if (noshort==1) { 
     W = m_mvportwos2(rettemp,vecw,covmat,mrets)
  }
  else {
     W = m_mvportws(rettemp,covmat,mrets)
  }
 if (i==1) {  
  WF=W
  }
  else  
   {  
   
    sumvar = colsum(covmat)'
	sumvar = J(rows(covmat),1,max(sumvar)) - sumvar
	csum=sum(sumvar)
	sumvar = sumvar/csum
    WFS=J(rows(covmat),100,0)

	for (j=0; j<=99; j++) {
	 WFS[.,j+1]=(j/100)*(maxwei*W) + (100-j)/100*(WF+extraweight*sumvar)
     WF1=m_buildwvector(vecmaxweights, Wind, WFS[.,j+1])
	 VAR1[j+1,1]=cross(WF1,COV)*WF1
	 VAR1[j+1,2]= (min(WF1-vecweights)<0)	 
    }
	VAR1_sort=order(VAR1,(2,1))
	WF=WFS[.,VAR1_sort[1]]
    retp=cross(WF,mrets)
	
	dif = (ret - cross(WN,MR)) - retp 
	sumvar = mrets
	sumvari = order(sumvar,1)

	j=1
	ind_max=cols(covmat)
	if (dif!=0) {  // 3 if dif!=0
	mwei = dif /(mrets[sumvari[ind_max]] - mrets[sumvari[j]])
    mwei2=mwei
	WF2=WF
	dd=J(2,1,0)
    while (mwei!=0) { // 4 while
	  k=0
	  WF2[sumvari[ind_max]] = WF2[sumvari[ind_max]] + mwei
	  WF2[sumvari[j]] = WF2[sumvari[j]] - mwei	  
	  dd[1,1]=WF2[sumvari[j]] - vecw[sumvari[j]]
	  dd[2,1]=vecmaxw[sumvari[ind_max]] - WF2[sumvari[ind_max]]
	  if (dd[1]<0 & dd[2]<0) { // 5 if dd
         ddi=order(dd,1)
    	 if (ddi[1]==1) {
		     k=1
		 }
		 else {
		     k=2
		 }
		 
		 if (mwei2>0) {
		   mwei2=mwei2+dd[ddi[1]]
		 }
		 else {
		   mwei2=mwei2-dd[dd[1]]
		 }
	  } // 5 if dd
	  else if (dd[1,1]<0) { // 5 if dd
	     k=1
	     if (mwei2>0) { 
		   mwei2=mwei2 + dd[1]
		 }
		 else {
		   mwei2=mwei2 - dd[1]
		 }
	  } // 5 if dd
	  else if (dd[2,1]<0) { // 5 if dd
	     k=2
	     if (mwei2>0) {
		   mwei2=mwei2 + dd[2]
		 }
		 else {
		   mwei2=mwei2 - dd[2]
		 }
	  } // 5 if dd
     WF[sumvari[ind_max]] = WF[sumvari[ind_max]] + mwei2
     WF[sumvari[j]] = WF[sumvari[j]] - mwei2
	 if (mwei>0) { 
	  mwei=mwei-mwei2
	 }
	 else {
	  mwei=mwei+mwei2
	 }
     if (k==1) { 
	  j++
	 }
	 else if (k==2) {
	   ind_max--
	 }
     if (k>0) {
      retp=cross(WF,mrets)
	  dif = (ret - cross(WN,MR)) - retp 
  	  mwei = dif /(mrets[sumvari[ind_max]] - mrets[sumvari[j]])
	 }
	 else { 
	   mwei=0
	 }
	 
	 WF2=WF
	mwei2=mwei
	} // 4 
	} // 3
 } // 2
  Wdif=vecmaxw - WF  
  Wdifsort=order(Wdif,1)
  coltodelete=Wdifsort[1]
  sigue = (Wdif[coltodelete] < 0 ? 1: 0)
  if (sigue) { // 2
     extraweight=-1*Wdif[coltodelete]
	 maxwei=maxwei - vecmaxw[coltodelete]
	 covmat=m_dropcolren(covmat,coltodelete)
     mrets=m_dropren(mrets,coltodelete) 
	 vecw=m_dropren(vecw,coltodelete)
	 vecmaxw=m_dropren(vecmaxw,coltodelete) 
	 Wind=m_dropren(Wind,coltodelete)
	 WF=m_dropren(WF,coltodelete)
	 if (rows(WF)==1) { 
	   WF[1]=maxwei
	 }
  
   WN = vecmaxweights
   for (j=1; j<=rows(Wind); j++) {
     WN[Wind[j]]=0
   }
  rettemp = (ret - cross(WN,MR)) / (1- colsum(WN))
 }  // 2
} // 1

W=m_buildwvector(vecmaxweights, Wind, WF)

retp=quadcross(W,MR)
varp=quadcross(W,COV)*W
riskp=sqrt(varp)
mcr=  COV*W :/ riskp
cr = mcr :*W
pcr = cr :/ riskp
betas = mcr :/ riskp

st_matrix("r(weights)",W)
st_matrix("r(cov)",COV)
st_matrix("r(exprets)",MR)
st_matrix("r(mcr)",mcr)
st_matrix("r(cr)",cr)
st_matrix("r(pcr)",pcr)
st_matrix("r(betas)",betas)

st_numscalar("r(retp)",retp)
st_numscalar("r(varp)",varp)
st_numscalar("r(sdp)",riskp)
st_numscalar("r(N)",rows(r))
return(W)
}
end
mata: mata mosave m_mvport2(), dir(PERSONAL) replace
