// mvport package v2
// Author: Alberto Dorantes, July, 2016
// cdorante@itesm.mx

version 11.0

mata:
mata clear
mata set matastrict on
void m_efrontiermws(string scalar varlist, real scalar nport, string scalar touse, string scalar casewis, real matrix covmatrix, real matrix mrets)
{
real matrix r, COV, INVCOV, COVMR, AA,VAA, W, MR, MATRET, VECRET, VB, wefws, refws, sdefws
real vector gmvp, pmvf
real scalar nr, retgmv, retmax, A, B, C, D, E, F
real scalar retp, riskp, varp
 st_view(r=.,.,tokens(varlist), touse)
if (cols(covmatrix)<=1) {
 COV=m_expvar(r,casewis)
 }
else {
  COV=covmatrix
}  
 
if (rows(mrets)<=1) {
  MR=m_exprets(r, casewis)
}
else {
  MR=mrets[.,1]
} 

 nr=rows(MR)
 INVCOV=cholinv(COV)
if (missing(INVCOV[1,1])) {
  INVCOV=invsym(COV)
}
 COVMR=cross(MR,INVCOV)
 A=rowsum(COVMR)
 B=cross(MR,INVCOV)*MR
 C=sum(INVCOV)
 D=B*C - A*A
 retgmv=A/C
 E=rowsum(INVCOV) 
 retmax = max(MR) + max(MR)
 VECRET = rangen(retgmv, retmax, nport)'
 F=INVCOV*MR
 MATRET = J(nr,1,VECRET)
 AA= (B*E - A*F)/D
 VAA=J(1,cols(MATRET),AA)
 wefws = VAA  + MATRET:*(C*F - A*E ) :/ D

 refws= cross(wefws,MR)
 wefws=wefws'
 VB=J(cols(MATRET),1,B)
 sdefws=sqrt((VB-2*VECRET'*A+C*VECRET':*VECRET') / D)
 
 st_matrix("r(cov)",COV)
 st_matrix("r(refws)",refws)
 st_matrix("r(wefws)",wefws)
 st_matrix("r(sdefws)",sdefws)
}
end
mata: mata mosave m_efrontiermws(), dir(PERSONAL) replace
