// mvport package v2
// Author: Alberto Dorantes, July, 2016
// cdorante@itesm.mx
version 11.0
mata:
mata set matastrict on
mata:

real matrix function m_genportaal(real scalar nport, N)
{  real matrix pmatp, dif, ptemp
  ptemp=runiform(N-1,nport)
  dif= J(1,nport,1) - colsum(ptemp) 
  ptemp=dif\ptemp
  pmatp=select(ptemp, ptemp[1,.]:>0)
  while (cols(pmatp)<nport) {
     ptemp=runiform(N-1,nport)
     dif= J(1,nport,1) - colsum(ptemp) 
     ptemp=dif\ptemp
	 ptemp=select(ptemp, ptemp[1,.]:>0)
	 pmatp=pmatp,ptemp
  }
  return(pmatp)
}
end
mata: mata mosave m_genportaal(), dir(PERSONAL) replace
