// mvport package v2
// Author: Alberto Dorantes, July, 2016
// cdorante@itesm.mx
version 11.0
mata:
mata clear
mata set matastrict on

mata:
real vector function m_mvf(real matrix COV, real vector MR, real scalar ret)
{ real vector E, F
  real matrix INVCOV, COVMR
  real scalar A,B,C,D, W
INVCOV=cholinv(COV)
if (missing(INVCOV[1,1])) {
  INVCOV=invsym(COV)
}

COVMR=quadcross(MR,INVCOV)
A=rowsum(COVMR)
B=COVMR*MR
C=sum(INVCOV)
E=rowsum(INVCOV)
F=INVCOV*MR
D=B*C-A*A
W=(B*E - A*F + ret*(C*F - A*E) ) / D
return(W)

}   
end
mata: mata mosave m_mvf(), dir(PERSONAL) replace
